//+------------------------------------------------------------------+
//|                                             Pivot Stochastic.mq4 |
//|                                                             Pooh |
//|                                                               NA |
//+------------------------------------------------------------------+
#property copyright "Pooh"
#property link      "NA"

extern int NumPips=10;          //4-digit pips
extern int BuyPercent=22;
extern int SellPercent=72;
extern int StpPips=100;         //4-digit pips      
extern int PftPips=40;          //4-digit pips
extern int StochL=14;
extern int Smooth1=3;
extern int Smooth2=3;
extern int LotDigit=1;
extern double Risk=1.0;
extern bool UseAutoMM=true;
extern double BaseLot=0.2;
extern int CrossPeriod=5;
extern int Magic=22000169;
extern int P_Distance=0;       // 4-digit pips


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
  
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----

int PipMulti,Signal;
if(Digits==3 || Digits==5)
PipMulti=10;
else
PipMulti=1;

int Total=0;

for(int i=0;i<OrdersTotal();i++)
{
OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
Total++;
}

Signal=TradeSignal();

if(Total<1 && Signal>0)
OpenBuyOrder(getLots(PipMulti),Ask-StpPips*0.0001);

if(Total<1 && Signal<0)
OpenSellOrder(getLots(PipMulti),Bid+StpPips*0.0001);







   
//----
   return(0);
  }
//+------------------------------------------------------------------+

double getLots(int PM)
{
   RefreshRates();
   
   double minLot = MarketInfo(Symbol(),MODE_MINLOT);
   double maxLot = MarketInfo(Symbol(),MODE_MAXLOT);
   double lots   = BaseLot;
   
   if (UseAutoMM==true)
   {
      if (Risk>0)
      {  
         lots = NormalizeDouble(AccountEquity()*Risk/(100*StpPips*0.0001)/100000,LotDigit);
      }
   }      
   return(lots);    //MathMax(MathMin(lots,maxLot),minLot)
 }
 
 
 int TradeSignal()
 {
  int Signal,Cond1,Cond2,Cond3,Cond4,Cond5=0;
  
  if((MathAbs(iLow(NULL,0,1)-iCustom(NULL,0,"Pivot points plus 1.02",1,1))<=0.0001*NumPips)|| (MathAbs(iLow(NULL,0,1)-iCustom(NULL,0,"Pivot points plus 1.02",3,1))<=0.0001*NumPips)||(MathAbs(iLow(NULL,0,1)-iCustom(NULL,0,"Pivot points plus 1.02",5,1))<=0.0001*NumPips))   //deleted:(MathAbs(iLow(NULL,0,1)-iCustom(NULL,0,"Pivot",1,1))<=0.0001*NumPips)||
   Cond1=1;
  
  for(int i=1;i<=5;i++)
  {
   if(iStochastic(NULL,0,StochL,Smooth1,Smooth2,0,0,0,i+1)<iStochastic(NULL,0,StochL,Smooth1,Smooth2,0,0,1,i+1) && iStochastic(NULL,0,StochL,Smooth1,Smooth2,0,0,0,i)>iStochastic(NULL,0,StochL,Smooth1,Smooth2,0,0,1,i))
   {
    Cond2=1;
    break;
    }
   }
  
  for(int j=2;j<=5;j++)
  {
   if(iStochastic(NULL,0,StochL,Smooth1,Smooth2,0,0,0,1)>BuyPercent && iStochastic(NULL,0,StochL,Smooth1,Smooth2,0,0,0,j)<BuyPercent) 
   {
   Cond3=1;
   break;
    }
   }
  
   if(iCustom(NULL,PERIOD_D1,"Cronex Taichi",0,1)>iCustom(NULL,PERIOD_D1,"Cronex Taichi",1,1))
   Cond4=1;
  
   
   
   if(MathAbs(iHigh(NULL,0,1)-iCustom(NULL,0,"Pivot points plus 1.02",2,1))<=0.0001*NumPips || MathAbs(iHigh(NULL,0,1)-iCustom(NULL,0,"Pivot points plus 1.02",4,1))<=0.0001*NumPips || MathAbs(iHigh(NULL,0,1)-iCustom(NULL,0,"Pivot points plus 1.02",6,1))<=0.0001*NumPips)
   Cond1=-1;
  
  for(int l=1;l<=5;l++)
  {
   if(iStochastic(NULL,0,StochL,Smooth1,Smooth2,0,0,0,l+1)>iStochastic(NULL,0,StochL,Smooth1,Smooth2,0,0,1,l+1) && iStochastic(NULL,0,StochL,Smooth1,Smooth2,0,0,0,l)<iStochastic(NULL,0,StochL,Smooth1,Smooth2,0,0,1,l))
   {
    Cond2=-1;
    break;
    }
   }
  
  for(int m=2;m<=5;m++)
  {
   if(iStochastic(NULL,0,StochL,Smooth1,Smooth2,0,0,0,1)<SellPercent && iStochastic(NULL,0,StochL,Smooth1,Smooth2,0,0,0,m)>SellPercent) 
   {
   Cond3=-1;
   break;
    }
   }
  
   if(iCustom(NULL,PERIOD_D1,"Cronex Taichi",0,1)<iCustom(NULL,PERIOD_D1,"Cronex Taichi",1,1))
   
   Cond4=-1;
   
  
  if(iCustom(NULL,0,"Pivot points plus 1.02",2,1)-iCustom(NULL,0,"Pivot points plus 1.02",1,1)>0.0001*P_Distance)
  Cond5=1;
  
  if(Cond1==1 && Cond2==1 && Cond3==1 && Cond4==1 && Cond5==1)             //deleted Cond4
  Signal=1;
  if(Cond1==-1 && Cond2==-1 && Cond3==-1 && Cond4==-1 && Cond5==1)       //deleted Cond4
  Signal=-1;
  
  
  
  return(Signal);
  }
  
  void OpenBuyOrder(double Lots_,double SLL_)
{
 int ticket=OrderSend(Symbol(),OP_BUY,Lots_,Ask,5,SLL_,Ask+PftPips*0.0001,"Pivot Sto long",Magic,0,Green);
       if (ticket>0)
          { 
           if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
           Print("Pivot Sto long opened : ",OrderOpenPrice());
                 
           else 
           Print("Error opening Pivot Sto long : ",GetLastError());
           return(0);
           }
 }  
 
 
 void OpenSellOrder(double Lots_,double SLS_)
 {
      int ticket=OrderSend(Symbol(),OP_SELL,Lots_,Bid,5,SLS_,Bid-PftPips*0.0001,"Pivot Sto short",Magic,0,Green);
       if (ticket>0)
          { 
           if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
           Print("Pivot Sto short opened : ",OrderOpenPrice());
                 
           else 
           Print("Error opening Pivot Sto short : ",GetLastError());
           return(0);     
           }
 } 